#include <QApplication>
#include <QMediaPlayer>
#include <QDebug>
#include <QDir>
#include <QTimer>

//--------------------------------------------------------------------------------------------------------------------------------------------------------------
class Sink : public QObject
{
  Q_OBJECT

  public:

    Sink() : QObject() {}

  public slots:

    void onStart()
    {
      QDir dir(".");

      QMediaPlayer player1;
      player1.setMedia(QUrl::fromLocalFile(dir.absoluteFilePath("chime.wav")));

      const int KIterationCount = 10;
      for (int i = 0; i < KIterationCount; ++i)
      {
        {
          QMediaPlayer player2; // comment this out to make all work
        }

        // play until finished
        player1.play();
        QEventLoop eventLoop;
        while(player1.state() != QMediaPlayer::StoppedState)
        {
          eventLoop.processEvents();
        }
      }

      QApplication::quit();
    }
};

#include "main.moc"
//--------------------------------------------------------------------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
  QApplication app(argc, argv);

  Sink sink;
  QTimer::singleShot(10, &sink, SLOT(onStart()));

  return app.exec();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------------
